/**
 * SNOWMANMOD
 * Version 0.4
 * By: R3DDS
 * 
 * Описание:
 * После включения плагина один игрок становится Т, а все остальные становятся КТ.
 * Если снеговик не умер он остаётся на следующий раунд. Кто его убъёт становится снеговиком.
 * У снеговика только нож, но у него огромная жизнь и скорость и гравитация. * other than a knife.
 * 
 * Админ может выбирать снегогвика в меню.
 * 
 * 
 * Требования:
 * AMXX 1.70+
 * Fun module
 * Fakemeta module
 * Hamandswich module
 * 
 * CVARS:
 * snowman_hp <#>
 *      Жизни снеговика (default: 20000)
 * snowman_speed <#>
 *      Скорость передвижения (default: 600)
 * snowman_rounds <#>
 *      Максимум раундов можно быть снеговиком (default: 3)
 * snowman_time <#>
 *      Времени до запуска рестарта (default: 10)
 * snowmanmod_custommodel <0/1>
 *      1 чтобы использовать свою модель, 0 стандарт (default: 1)
 * snowman_gravity <#>
 *      Гравитация снеговика (default: 0.6)
 * 
 * Команды:
 * amx_snowman <0/1>
 *      1 включить мод, 0 отключить
 * amx_snowmanmenu
 *      Выбрать снеговика в меню
 * 
 * Модель:
 * Модель: "models/player/snowmanmod/snowmanmod.mdl"
 */


#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <fun>
#include <fakemeta>
#include <hamsandwich>

#define PLUGIN	"SnowmanMod"
#define VERSION	"0.4"
#define AUTHOR	"R3DDS"

#define MENU_SIZE    256
#define MENU_PLAYERS 8

#define SNOWMAN_MODEL "snowmanmod"
#define SNOWMAN_MODEL_DIR "models/player/zbs_bossl_big02/zbs_bossl_big02.mdl"
#define SNOWMAN_SOUND "sound/misc/snow_idle.wav"

#define ADMIN_REQ ADMIN_RCON
#define BLOOD_COLOR_WHITE    245

new g_iMenuPosition
new g_iMenuPlayers[32]

new g_maxRounds
new g_timer
new g_speed
new g_maxhealth
new g_custommodel
new g_gravity

new g_enabled = 0
new g_roundsPlayed = 0
new g_currentSnowman = 0
new g_nextSnowman = 0
new blockteams

public plugin_init()
{
  register_plugin(PLUGIN, VERSION, AUTHOR)  
  
  RegisterHam(Ham_BloodColor, "player", "fw_BloodColorPre")
  
  register_clcmd("amx_snowman", "setEnabled", ADMIN_REQ, "- <0/1> Включить снеговика")
  register_clcmd("amx_snowmanmenu", "ShowMenu", ADMIN_REQ, "- Выбрать снеговика")
  register_menucmd( register_menuid("\rМеню игрока:"), 1023, "MenuAction" )
  
  
  register_clcmd("jointeam", "join_team")
  register_menucmd(register_menuid("Team_Select",1), (1<<0)|(1<<1)|(1<<4)|(1<<5), "team_select")
  
  register_logevent("event_roundStart", 2, "1=Round_Start")
  register_event("HLTV", "event_newRound", "a", "1=0", "2=0")
  register_event("DeathMsg", "event_deathMsg", "a", "1>0")
  register_event("CurWeapon","event_curWeapon", "be", "1=1")
  register_forward(FM_Touch,"on_touch")
    
  g_maxRounds = register_cvar("snowman_rounds", "1")
  g_speed = register_cvar("snowman_speed", "600")
  g_timer = register_cvar("snowman_time", "10")
  g_maxhealth = register_cvar("snowman_hp", "40000")
  g_gravity = register_cvar("snowman_gravity", "0.6")
  
  blockteams = g_enabled ? PLUGIN_HANDLED : PLUGIN_CONTINUE
}

public plugin_precache()
{
  g_custommodel = register_cvar("snowmanmod_custommodel", "1")
  
  if (get_pcvar_num(g_custommodel)) {
    precache_model(SNOWMAN_MODEL_DIR)
	precache_sound(SNOWMAN_SOUND)
  }
  return PLUGIN_CONTINUE
}


public fw_BloodColorPre(id)
{
    if(is_user_connected(g_currentSnowman))
    {
        SetHamReturnInteger(BLOOD_COLOR_WHITE)
        return HAM_SUPERCEDE
    }

    return HAM_IGNORED
}


public setEnabled(id, lvl, cid)
{
  if(cmd_access(id, lvl, cid, 2)) {
    new str[2]
    read_argv(1, str, 1)
    str_to_num(str) ? startSnowmanMod() : stopSnowmanMod()
  }
}

public startSnowmanMod()
{
  g_enabled = 1
  setServerSettings()
  lockTeams()
  
  new command[64]
  format(command, 63, "sv_restartround %f", get_pcvar_float(g_timer))
  server_cmd(command)
  client_print(0, print_chat, "[Снеговик] Снеговик появится через %f секунд.", get_pcvar_float(g_timer))
}

public stopSnowmanMod()
{  
  if (g_currentSnowman) {
    cs_reset_user_model(g_currentSnowman)
    set_user_maxspeed(g_currentSnowman, 0.0)
    set_user_gravity(g_currentSnowman, 0.6)
  }

  g_enabled = 0
  g_currentSnowman = 0
  g_nextSnowman = 0
  g_roundsPlayed = 0
  unlockTeams()
  
  client_print(0, print_chat, "[Снеговик] Снеговик выключен.")
}

public ShowMenu(id, lvl, cid)
{
  if(cmd_access(id, lvl, cid, 0))
    ShowPlayerMenu(id, g_iMenuPosition = 0)
  return PLUGIN_HANDLED
}

public ShowPlayerMenu(id, pos)
{
  if(pos < 0) return

  new i, j
  new szMenuBody[MENU_SIZE]
  new iCurrKey = 0
  new szUserName[32]
  new iStart = pos * MENU_PLAYERS
  new iNum

  get_players( g_iMenuPlayers, iNum )

  if( iStart >= iNum )
    iStart = pos = g_iMenuPosition = 0

  new iLen = format( szMenuBody, MENU_SIZE-1, "\rМеню игрока:\R%d/%d^n\w^n", pos+1, (iNum / MENU_PLAYERS + ((iNum % MENU_PLAYERS) ? 1 : 0 )) )
  new iEnd = iStart + MENU_PLAYERS
  new iKeys = (1<<9|1<<7)

  if( iEnd > iNum )
    iEnd = iNum

  for( i = iStart; i < iEnd; i++)
  {
    j = g_iMenuPlayers[i]
    get_user_name( j, szUserName, 31 )
    if( (get_user_flags(j) & ADMIN_IMMUNITY) || !is_user_alive(j) )
    {
      iCurrKey++
      iLen += format( szMenuBody[iLen], (MENU_SIZE-1-iLen), "\d%d. %s^n\w", iCurrKey, szUserName )
    }else
    {
      iKeys |= (1<<iCurrKey++)
      iLen += format( szMenuBody[iLen], (MENU_SIZE-1-iLen), "%d. %s^n", iCurrKey, szUserName )
    }
  }

  if( iEnd != iNum ) {
    format( szMenuBody[iLen], (MENU_SIZE-1-iLen), "^n9. Больше...^n0. %s", pos ? "Назад" : "Выход" )
    iKeys |= (1<<8)
  }
  else {
    format( szMenuBody[iLen], (MENU_SIZE-1-iLen), "^n0. %s", pos ? "Назад" : "Выход" )
  }

  show_menu( id, iKeys, szMenuBody, -1 )
  return
}

public MenuAction(id, key)
{
  switch(key)
  {
    case 8: ShowPlayerMenu( id, ++g_iMenuPosition )
    case 9: ShowPlayerMenu( id, --g_iMenuPosition )

    default:
    {
      new iPlayerID = g_iMenuPlayers[g_iMenuPosition * MENU_PLAYERS + key]

      new szUsername[32]
      get_user_name( iPlayerID, szUsername, 31 )
      client_print(0, print_chat, "[Снеговик] %s был выбран следующим снеговиком!", szUsername)
      g_nextSnowman = iPlayerID;
    }
  }
  return PLUGIN_HANDLED
}





public createNewSnowman()
{
  if (g_currentSnowman) {
    cs_reset_user_model(g_currentSnowman)
  }
  
  new players[32], num
  get_players(players, num)
  for (new i = 0; i < num; i++) {
    cs_set_user_team(players[i], CS_TEAM_CT)
  }
    
  if (g_nextSnowman == 0 || !is_user_connected(g_nextSnowman) || get_user_team(g_nextSnowman) == 3) {
    g_nextSnowman = players[random(num)]
  }

  g_currentSnowman = g_nextSnowman;
  g_nextSnowman = 0;
  g_roundsPlayed = 0
  
  cs_set_user_team(g_currentSnowman, CS_TEAM_T)
  
  if (g_custommodel) {
    cs_set_user_model(g_currentSnowman, SNOWMAN_MODEL)
  }
  
  new name[33]
  get_user_name(g_currentSnowman, name, 32)
  client_print(0, print_chat, "[Снеговик] Новый снеговик: %s!", name)
}

public updateSnowman()
{
  set_user_health(g_currentSnowman, get_pcvar_num(g_maxhealth))
  set_user_gravity(g_currentSnowman, get_pcvar_float(g_gravity))
  set_task(0.5, "event_curWeapon", g_currentSnowman)
  
  g_roundsPlayed++
  client_print(0, print_chat, "[Снеговик] Начало раунда %i/%i!", g_roundsPlayed, get_pcvar_num(g_maxRounds))
}




public event_newRound()
{
  if (g_enabled && (g_roundsPlayed == get_pcvar_num(g_maxRounds) || g_nextSnowman != 0
  || !is_user_connected(g_currentSnowman) || get_user_team(g_currentSnowman) != 1 || g_currentSnowman == 0)) {
    createNewSnowman()
  }
}

public event_roundStart()
{
  if (g_enabled) {
    updateSnowman()
  }
}

public event_deathMsg()
{
  if (g_enabled) {
    new killer = read_data(1)
    new victim = read_data(2)
    
    if (victim == g_currentSnowman && killer != victim && killer <= 32) {
      g_nextSnowman = killer;
      new name[33]
      get_user_name(g_nextSnowman, name, 32)
      client_print(0, print_chat, "[Снеговик] %s смертельно ранен! Следующий снеговик: %s!", name, name)
    }
  }
  
  return PLUGIN_CONTINUE
}

public setServerSettings()
{
  server_cmd("mp_limitteams 0")
  server_cmd("mp_autoteambalance 0")
  server_cmd("sv_maxspeed 1000")
  server_cmd("mp_roundtime 5")
}





public event_curWeapon(id)
{
  if (g_enabled && id == g_currentSnowman) {
    new weapons[32], num
    get_user_weapons(g_currentSnowman, weapons, num)
    if (num > 1) {
      strip_user_weapons(g_currentSnowman)
      give_item(g_currentSnowman, "weapon_knife")
    }
    set_user_maxspeed(g_currentSnowman, get_pcvar_float(g_speed))
  }
}

public on_touch(ent, id)
{
  if (id == g_currentSnowman) {
    if (!pev_valid(ent))
      return FMRES_IGNORED

    static classname[32]
    pev(ent,pev_classname,classname,sizeof classname-1)

    if ( (!equal(classname,"weapon",6)) && (!equal(classname,"armoury",7)) )
        return FMRES_IGNORED
    
    return FMRES_SUPERCEDE
  }
  return FMRES_IGNORED
}


public lockTeams()
{
  blockteams = PLUGIN_HANDLED
  return PLUGIN_HANDLED
}

public unlockTeams()
{
  blockteams = PLUGIN_CONTINUE
  return PLUGIN_HANDLED
}

public team_select(id, key){
  if ( (key == 0 || key == 4) && blockteams == PLUGIN_HANDLED ) {
    engclient_cmd(id,"chooseteam")
    return PLUGIN_HANDLED
  }
  return PLUGIN_CONTINUE
}

public join_team(id)
{
  new arg[2]
  read_argv(1, arg, 1)
  new key = str_to_num(arg)-1
  if ( (key == 0 || key == 4) && blockteams == PLUGIN_HANDLED ) {
    engclient_cmd(id,"chooseteam")
    return PLUGIN_HANDLED
  }
  return PLUGIN_CONTINUE
}